import { ListResponse, WarrantObject, ListPermissionParams, CreateRoleParams, ListRoleParams, UpdateRoleParams, Warrant, PermissionCheckParams } from "../types";
import Permission from "./Permission";
import { WarrantRequestOptions } from "../types/WarrantRequestOptions";
export default class Role implements WarrantObject {
    roleId: string;
    meta?: {
        [key: string]: any;
    };
    constructor(roleId: string, meta: {
        [key: string]: any;
    });
    static create(role?: CreateRoleParams, options?: WarrantRequestOptions): Promise<Role>;
    static get(roleId: string, options?: WarrantRequestOptions): Promise<Role>;
    static update(roleId: string, params: UpdateRoleParams, options?: WarrantRequestOptions): Promise<Role>;
    static delete(roleId: string, options?: WarrantRequestOptions): Promise<string>;
    static listRoles(listParams?: ListRoleParams, options?: WarrantRequestOptions): Promise<ListResponse<Role>>;
    static listRolesForUser(userId: string, listParams?: ListRoleParams, options?: WarrantRequestOptions): Promise<ListResponse<Role>>;
    static assignRoleToUser(userId: string, roleId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    static removeRoleFromUser(userId: string, roleId: string, options?: WarrantRequestOptions): Promise<string>;
    listPermissions(listParams?: ListPermissionParams, options?: WarrantRequestOptions): Promise<ListResponse<Permission>>;
    assignPermission(permissionId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    removePermission(permissionId: string, options?: WarrantRequestOptions): Promise<string>;
    hasPermission(params: PermissionCheckParams, options?: WarrantRequestOptions): Promise<boolean>;
    getObjectType(): string;
    getObjectId(): string;
}
